Index: trunk/gui/scripts/deviceLayout1D.tcl
===================================================================
--- trunk/gui/scripts/deviceLayout1D.tcl	(revision 6716)
+++ trunk/gui/scripts/deviceLayout1D.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: deviceLayout1D - visualizer for 1D device geometries
@@ -10,18 +9,15 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itk
 package require BLT
 
-option add *DeviceLayout1D.width 3.5i widgetDefault
+option add *DeviceLayout1D.width 4i widgetDefault
 option add *DeviceLayout1D.deviceSize 0.25i widgetDefault
 option add *DeviceLayout1D.deviceOutline black widgetDefault
 option add *DeviceLayout1D.annotate all widgetDefault
 option add *DeviceLayout1D.font \
-    -*-helvetica-medium-r-normal-*-12-* widgetDefault
+    -*-helvetica-medium-r-normal-*-*-120-* widgetDefault
 
 itcl::class Rappture::DeviceLayout1D {
@@ -29,6 +25,6 @@
 
     itk_option define -font font Font ""
+    itk_option define -library library Library ""
     itk_option define -device device Device ""
-    itk_option define -width width Width 0
     itk_option define -devicesize deviceSize DeviceSize 0
     itk_option define -deviceoutline deviceOutline DeviceOutline ""
@@ -44,5 +40,5 @@
     protected method _redraw {}
     protected method _drawLayer {index x0 x1}
-    protected method _drawIcon {index x0 x1 imh}
+    protected method _drawMolecule {index x0 x1}
     protected method _drawAnnotation {index x0 x1}
     protected method _mater2color {mater}
@@ -51,23 +47,25 @@
     private variable _sizes         ;# maps size name => pixels
 
+    private variable _library ""    ;# LibraryObj for library information
     private variable _device ""     ;# LibraryObj for device representation
     private variable _slabs ""      ;# list of node names for slabs in device
     private variable _z0 ""         ;# list parallel to _slabs with z0
                                     ;#   coord for lhs of each slab
-    private variable _z1 ""         ;# list parallel to _slabs with z1
-                                    ;#   coord for rhs of each slab
+    private variable _zthick ""     ;# list parallel to _slabs with thickness
+                                    ;#   for each slab
     private variable _maters ""     ;# list parallel to _slabs with material
                                     ;#   for each slab
-    private variable _colors ""     ;# list parallel to _slabs with color
-                                    ;#   for each slab
 
     private variable _controls      ;# maps control path => status on/off
 
-    private variable _icons         ;# maps icon data => image handle
-}
-
+    private common _icons
+    set _icons(molecule) [image create photo -file \
+        [file join $Rappture::installdir scripts images molecule.gif]]
+}
+                                                                                
 itk::usual DeviceLayout1D {
     keep -background -cursor
-    keep -device -deviceoutline -devicesize
+    keep -library -device
+    keep -deviceoutline -devicesize
     keep -selectbackground -selectforeground -selectborderwidth
     keep -width
@@ -84,4 +82,5 @@
     $_dispatcher dispatch $this !redraw "[itcl::code $this _redraw]; list"
 
+    itk_option add hull.width
     pack propagate $itk_component(hull) no
 
@@ -93,12 +92,9 @@
         ignore -highlightthickness -highlightbackground -highlightcolor
     }
-    pack $itk_component(area) -expand yes -fill both
+    pack $itk_component(area) -fill both
     bind $itk_component(area) <Configure> \
         [list $_dispatcher event -idle !redraw]
 
     eval itk_initialize $args
-
-    set _sizes(header) 1
-    set _sizes(bararea) 1
 }
 
@@ -116,5 +112,5 @@
     }
     set zmin [lindex $_z0 0]
-    set zmax [lindex $_z1 end]
+    set zmax [lindex $_z0 end]
     return [list $zmin $zmax]
 }
@@ -140,6 +136,6 @@
 #
 # Clients use this to add hints about the controls that should be
-# added to the layout area.  Common paths are components.slab#.material
-# and components.slab#.thickness.
+# added to the layout area.  Common paths are recipe.slab#.material
+# and recipe.slab#.thickness.
 # ----------------------------------------------------------------------
 itcl::body Rappture::DeviceLayout1D::controls {option args} {
@@ -169,56 +165,25 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::DeviceLayout1D::_layout {} {
-    #
-    # First, recompute the overall width/height of this widget...
-    #
-    # requested minimum size
-    set wmax [winfo pixels $itk_component(hull) $itk_option(-width)]
-    if {$wmax <= 0} { set wmax 100 }
-
-    # size of an ordinary material bar:
-    set hmax [expr {$_sizes(bar)+$_sizes(bar45)+2}]
-
-    # add the maximum size of any embedded icons:
-    if {$_device != ""} {
-        foreach nn [$_device children components] {
-            set icon [$_device get components.$nn.about.icon]
-            if {"" != $icon} {
-                if {[info exists _icons($icon)]} {
-                    set imh $_icons($icon)
-                } else {
-                    set imh [image create photo -data $icon]
-                    set _icons($icon) $imh
-                }
-
-                set w [image width $_icons($icon)]
-                if {$w > $wmax} {
-                    set wmax $w
-                }
-
-                set h [image height $_icons($icon)]
-                if {$h > $hmax} {
-                    set hmax $h
-                }
-            }
-        }
-    }
-    set _sizes(bararea) $hmax
+    # first, recompute the overall height of this widget
+    set h [expr {$_sizes(bar)+$_sizes(bar45)+20}]
 
     set fnt $itk_option(-font)
-    # see if any of the slabs has a material
-    foreach m $_maters {
-        if {"" != $m} {
-            set extra [expr {1.5*[font metrics $fnt -linespace]}]
-            set hmax [expr {$hmax+$extra}]
-            break
-        }
+    if {[regexp {\.material} [array names _controls]]} {
+        # one of the slabs has its material displayed
+        set extra [expr {1.2*[font metrics $fnt -linespace]}] 
+        set h [expr {$h+$extra}]
+    }
+    if {[regexp {\.thickness} [array names _controls]]} {
+        # one of the slabs has its thickness displayed
+        set extra [expr {1.2*[font metrics $fnt -linespace]}] 
+        set h [expr {$h+$extra}]
     }
 
     # see if any of the slabs has a label
     if {$_device != ""} {
-        foreach nn [$_device children components] {
-            if {"" != [$_device get components.$nn.about.label]} {
-                set extra [expr {1.2*[font metrics $fnt -linespace]}]
-                set hmax [expr {$hmax+$extra}]
+        foreach nn [$_device get -children recipe] {
+            if {"" != [$_device get recipe.$nn.label]} {
+                set extra [expr {1.2*[font metrics $fnt -linespace]}] 
+                set h [expr {$h+$extra}]
                 break
             }
@@ -226,57 +191,35 @@
     }
 
-    set oldw [component hull cget -width]
+    # a little extra height for the molecule image
+    if {[$_device get -exists recipe.molecule]} {
+        set h [expr {$h+15}]
+    }
+
     set oldh [component hull cget -height]
-    if {$wmax != $oldw || $hmax != $oldh} {
-        component hull configure -width $wmax -height $hmax
+    if {$h != $oldh} {
+        component hull configure -height $h
         $_dispatcher event -idle !redraw
     }
-    set _sizes(header) [expr {$hmax - $_sizes(bararea)}]
 
     # next, scan through the device and compute layer positions
     set slabs ""
     set z0 ""
-    set z1 ""
+    set zthick ""
     set maters ""
-    set colors ""
-
+
+    set z 0
     if {$_device != ""} {
-        # get the default system of units
-        set units [set defunits [$_device get units]]
-        if {$units == "arbitrary" || $units == ""} {
-            set defunits "m"
-            set units "um"
-        }
-
-        foreach nn [$_device children components] {
+        foreach nn [$_device get -children recipe] {
             switch -glob -- $nn {
-                box* {
-                    # get x-coord for each corner
-                    set c0 [$_device get components.$nn.corner0]
-                    regsub -all , $c0 { } c0
-                    set c0 [lindex $c0 0]
-                    set c0 [Rappture::Units::convert $c0 \
-                        -context $defunits -to $units -units off]
-
-                    set c1 [$_device get components.$nn.corner1]
-                    regsub -all , $c1 { } c1
-                    set c1 [lindex $c1 0]
-                    set c1 [Rappture::Units::convert $c1 \
-                        -context $defunits -to $units -units off]
-
-                    lappend slabs components.$nn
-                    lappend z0 $c0
-                    lappend z1 $c1
-
-                    set m [$_device get components.$nn.material]
-                    lappend maters $m
-
-                    if {"" != $m} {
-                        set c [_mater2color $m]
-                    } else {
-                        set c [$_device get components.$nn.about.color]
-                    }
-                    if {"" == $c} { set c gray }
-                    lappend colors $c
+                slab* - molecule* {
+                    set tval [$_device get recipe.$nn.thickness]
+                    set tval [Rappture::Units::convert $tval \
+                        -context um -to um -units off]
+                    lappend slabs recipe.$nn
+                    lappend z0 $z
+                    lappend zthick $tval
+                    lappend maters [$_device get recipe.$nn.material]
+
+                    set z [expr {$z+$tval}]
                 }
                 default {
@@ -286,15 +229,14 @@
         }
     }
+    lappend z0 $z
 
     # something change? then store new layout and redraw
     if {![string equal $z0 $_z0]
-          || ![string equal $z1 $_z1]
-          || ![string equal $maters $_maters]
-          || ![string equal $colors $_colors]} {
+          || ![string equal $zthick $_zthick]
+          || ![string equal $maters $_maters]} {
         set _slabs $slabs
         set _z0 $z0
-        set _z1 $z1
+        set _zthick $zthick
         set _maters $maters
-        set _colors $colors
 
         $_dispatcher event -idle !redraw
@@ -312,4 +254,7 @@
 
     # clean up images and delete all other items
+    foreach item [$c find withtag image] {
+        image delete [$c itemcget $item -image]
+    }
     $c delete all
 
@@ -319,28 +264,36 @@
     set x1 [expr {$x0 + $w}]
 
-    set zmax [lindex $_z1 end]
+    set zmax [lindex $_z0 end]
     set xx0 $x0
     set xx1 $x1
 
+    set drewslab 0
     for {set i 0} {$i < [llength $_slabs]} {incr i} {
         set name [lindex $_slabs $i]
-        set z0 [lindex $_z0 $i]
-        set z1 [lindex $_z1 $i]
-        set xx0 [expr {double($z0)/$zmax * ($x1-$x0) + $x0}]
-        set xx1 [expr {double($z1)/$zmax * ($x1-$x0) + $x0}]
-
-        set icon [$_device get $name.about.icon]
-        if {"" != $icon} {
-            if {[info exists _icons($icon)]} {
-                set imh $_icons($icon)
-            } else {
-                set imh [image create photo -data $icon]
-                set _icons($icon) $imh
+        if {[regexp {slab[0-9]*$} $name]} {
+            set z0 [lindex $_z0 $i]
+            set zthick [lindex $_zthick $i]
+            set xx0 [expr {double($z0)/$zmax * ($x1-$x0) + $x0}]
+            set xx1 [expr {double($z0+$zthick)/$zmax * ($x1-$x0) + $x0}]
+            _drawLayer $i $xx0 $xx1
+            _drawAnnotation $i $xx0 $xx1
+            set drewslab 1
+        } else {
+            if {$drewslab} {
+                _drawLayer cap $xx0 $xx1  ;# draw the end cap
+                set drewslab 0
             }
-            _drawIcon $i $xx0 $xx1 $imh
-        } else {
-            _drawLayer $i $xx0 $xx1
-        }
-        _drawAnnotation $i $xx0 $xx1
+            if {[regexp {molecule[0-9]*$} $name]} {
+                set z0 [lindex $_z0 $i]
+                set zthick [lindex $_zthick $i]
+                set xx0 [expr {double($z0)/$zmax * ($x1-$x0) + $x0}]
+                set xx1 [expr {double($z0+$zthick)/$zmax * ($x1-$x0) + $x0}]
+                _drawMolecule $i $xx0 $xx1
+                _drawAnnotation $i $xx0 $xx1
+            }
+        }
+    }
+    if {[llength $_slabs] > 0} {
+        _drawLayer cap $xx0 $xx1  ;# draw the end cap
     }
 }
@@ -355,8 +308,11 @@
 itcl::body Rappture::DeviceLayout1D::_drawLayer {index x0 x1} {
     set c $itk_component(area)
-    set h [expr {$_sizes(header) + $_sizes(bararea) - 1}]
-
-    set bsize [expr {$_sizes(bar)+$_sizes(bar45)+2}]
-    set y0 [expr {$h - 0.5*$_sizes(bararea) + 0.5*$bsize}]
+    set h [expr {[winfo height $c]-1}]
+    # a little extra height for the molecule image
+    if {[$_device get -exists recipe.molecule]} {
+        set h [expr {$h-15}]
+    }
+
+    set y0 $h
     set y0p [expr {$y0-$_sizes(bar45)}]
     set y1p [expr {$y0-$_sizes(bar)}]
@@ -368,6 +324,12 @@
     set lcolor $itk_option(-deviceoutline)
 
-    if {$index < [llength $_slabs]} {
-        set fcolor [lindex $_colors $index]
+    if {$index == "cap"} {
+        #
+        # Draw the outline around the end cap
+        #
+        $c create line $x1 $y0  $x1 $y1p  $x1p $y1 -fill $lcolor
+
+    } elseif {$index < [llength $_slabs]} {
+        set fcolor [_mater2color [lindex $_maters $index]]
 
         #
@@ -385,37 +347,39 @@
             -outline $lcolor -fill $fcolor
         $c create line $x0 $y1p  $x1 $y1p -fill $lcolor
-
-        #
-        # Draw the outline around the end cap
-        #
-        $c create line $x1 $y0  $x1 $y1p  $x1p $y1 -fill $lcolor
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: _drawIcon <index> <x0> <x1> <imh>
-#
-# Used internally within _redraw to draw a material layer that is
-# represented by an icon.  The layer sits at <index> within the slab
-# list into the active area.  The layer is drawn between coordinates
-# <x0> and <x1> on the canvas.
-# ----------------------------------------------------------------------
-itcl::body Rappture::DeviceLayout1D::_drawIcon {index x0 x1 imh} {
+    }
+}
+
+# ----------------------------------------------------------------------
+# USAGE: _drawMolecule <index> <x0> <x1>
+#
+# Used internally within _redraw to draw one molecule layer at the
+# <index> within the slab list into the active area.  The layer is
+# drawn between coordinates <x0> and <x1> on the canvas.
+# ----------------------------------------------------------------------
+itcl::body Rappture::DeviceLayout1D::_drawMolecule {index x0 x1} {
     set c $itk_component(area)
-    set h [expr {$_sizes(header) + $_sizes(bararea) - 1}]
-
-    set bsize [expr {$_sizes(bar)+$_sizes(bar45)+2}]
-    set y0 [expr {$h - 0.5*$_sizes(bararea) + 0.5*$bsize}]
+    set h [expr {[winfo height $c]-1}]
+    # a little extra height for the molecule image
+    if {[$_device get -exists recipe.molecule]} {
+        set h [expr {$h-15}]
+    }
+
+    set y0 $h
     set y0p [expr {$y0-$_sizes(bar45)}]
     set y1p [expr {$y0-$_sizes(bar)}]
     set y1 [expr {$y1p-$_sizes(bar45)}]
     set x0p [expr {$x0+$_sizes(bar45)}]
-    set x1p [expr {$x1+$_sizes(bar45)}]
-
-    set xx0 [expr {0.5*($x0+$x0p)}]
-    set xx1 [expr {0.5*($x1+$x1p)}]
+
+    set x [expr {0.5*($x0+$x0p)}]
     set y [expr {0.5*($y0+$y0p) + 0.5*($y1-$y0p)}]
 
-    $c create image [expr {0.5*($xx0+$xx1)}] $y -anchor c -image $imh
+    set w [image width $_icons(molecule)]
+    set h [image height $_icons(molecule)]
+    set dx [expr {round($x1-$x0)}]
+    set dy [expr {round(double($x1-$x0)/$w*$h)}]
+    set imh [image create photo -width $dx -height $dy]
+    blt::winop resample $_icons(molecule) $imh
+
+    $c create image $x $y -anchor w -image $imh -tags image
 }
 
@@ -429,6 +393,13 @@
 itcl::body Rappture::DeviceLayout1D::_drawAnnotation {index x0 x1} {
     set c $itk_component(area)
-
-    set ytop [expr {$_sizes(header)+1}]
+    set h [expr {[winfo height $c]-1}]
+    # a little extra height for the molecule image
+    if {[$_device get -exists recipe.molecule]} {
+        set h [expr {$h-15}]
+    }
+
+    set y0 $h
+    set y1 [expr {$y0-$_sizes(bar)-$_sizes(bar45)}]
+
     set x0p [expr {$x0+$_sizes(bar45)}]
     set x1p [expr {$x1+$_sizes(bar45)}]
@@ -437,6 +408,23 @@
     set fnt $itk_option(-font)
     set lh [font metrics $fnt -linespace]
-    set ymid [expr {$ytop-2-0.5*$lh}]
-    set y [expr {$ytop-4}]
+    set ymid [expr {$y1-2-0.5*$lh}]
+    set y [expr {$y1-2}]
+
+    #
+    # If there's a .thickness control for this slab, draw it here.
+    #
+    set elem [lindex $_slabs $index]
+    set path "device.$elem.thickness"
+    if {[info exists _controls($path)] && $_controls($path)} {
+        set zthick [lindex $_zthick $index]
+        set zthick [Rappture::Units::convert $zthick -context um -to um]
+
+        $c create line $x0p $y $x0p [expr {$y-$lh}]
+        $c create line $x1p $y $x1p [expr {$y-$lh}]
+
+        $c create line $x0p $ymid $x1p $ymid -arrow both
+        $c create text $xmid [expr {$ymid-2}] -anchor s -text $zthick
+        set y [expr {$y-2.0*$lh}]
+    }
 
     #
@@ -444,14 +432,14 @@
     #
     set elem [lindex $_slabs $index]
-    set mater [lindex $_maters $index]
-    if {"" != $mater} {
-        set x $x1p
-        $c create rectangle [expr {$x-10}] [expr {$y-14}] \
-            [expr {$x-0}] [expr {$y-4}] \
-            -outline black -fill [_mater2color $mater]
-        set x [expr {$x-12}]
-        $c create text $x [expr {$y-7}] -anchor e \
+    set path "device.$elem.material"
+    if {[info exists _controls($path)] && $_controls($path)} {
+        set mater [lindex $_maters $index]
+        set w [expr {12+[font measure $fnt $mater]}]
+        set x [expr {$x1p - 0.5*($x1p-$x0p-$w)}]
+        $c create rectangle [expr {$x-10}] [expr {$y-10}] \
+            $x $y -outline black -fill [_mater2color $mater]
+        $c create text [expr {$x-12}] [expr {$y-5}] -anchor e \
             -text $mater
-        set y [expr {$y-1.5*$lh}]
+        set y [expr {$y-1.2*$lh}]
     }
 
@@ -460,6 +448,7 @@
     #
     if {"" != $_device} {
-        set label [$_device get $elem.about.label]
+        set label [$_device get "$elem.label"]
         if {"" != $label} {
+            set y [expr {$y-0.5*$lh}]
             $c create text [expr {0.5*($x0p+$x1p)}] $y -anchor s \
                 -text $label
@@ -475,8 +464,9 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::DeviceLayout1D::_mater2color {mater} {
-    set lib [Rappture::library standard]
-    set color [$lib get materials.($mater).color]
-    if {$color != ""} {
-        return $color
+    if {$_library != ""} {
+        set color [$_library get materials.$mater.color]
+        if {$color != ""} {
+            return $color
+        }
     }
     return gray
@@ -491,4 +481,20 @@
 itcl::configbody Rappture::DeviceLayout1D::font {
     $_dispatcher event -idle !layout
+}
+
+# ----------------------------------------------------------------------
+# CONFIGURATION OPTION: -library
+#
+# Set to the Rappture::Library object representing the library with
+# material properties and other info.
+# ----------------------------------------------------------------------
+itcl::configbody Rappture::DeviceLayout1D::library {
+    if {$itk_option(-library) != ""} {
+        if {![Rappture::Library::valid $itk_option(-library)]} {
+            error "bad value \"$itk_option(-library)\": should be Rappture::Library"
+        }
+    }
+    set _library $itk_option(-library)
+    $_dispatcher event -idle !redraw
 }
 
@@ -502,24 +508,10 @@
 itcl::configbody Rappture::DeviceLayout1D::device {
     if {$itk_option(-device) != ""} {
-        if {![Rappture::library isvalid $itk_option(-device)]} {
+        if {![Rappture::Library::valid $itk_option(-device)]} {
             error "bad value \"$itk_option(-device)\": should be Rappture::Library"
         }
     }
     set _device $itk_option(-device)
-    $_dispatcher event -idle !layout
-}
-
-# ----------------------------------------------------------------------
-# CONFIGURATION OPTION: -width
-#
-# Sets the minimum overall width of the widget.
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::DeviceLayout1D::width {
-    if {[catch {
-          winfo pixels $itk_component(hull) $itk_option(-width)
-      } pixels]} {
-        error "bad screen distance \"$itk_option(-width)\""
-    }
-    $_dispatcher event -idle !layout
+    $_dispatcher event -idle !redraw
 }
 
